module IpWhitelist
  module Interceptor
    extend ActiveSupport::Concern

    included do
      before_action :ip_intercept

      rescue_from IpWhitelist::Error do |e|
        render json: { code: e.code, message: e.message }, status: e.status
      end

      def ip_intercept
        unless IpWhitelist::List.ips.include?(request.ip)
          raise IpWhitelist::Error.new(status: 403, message: 'Invaild Request')
        end
      end
    end
  end
end

